package ru.dbotthepony.mc.otm.container;

import net.minecraft.world.Container;
import net.minecraft.world.item.ItemStack;
import net.minecraftforge.common.capabilities.Capability;

import java.util.Iterator;
import java.util.Optional;
import java.util.function.Consumer;

public class ContainerIteratorCapability<T> implements java.util.Iterator<T>, Iterable<T> {
	private final Container container;
	private final Capability<T> cap;
	private int index = 0;
	private T next_stack;

	public ContainerIteratorCapability(Container container, Capability<T> cap) {
		this.container = container;
		this.cap = cap;
	}

	@Override
	public boolean hasNext() {
		if (index >= container.getContainerSize() && next_stack == null)
			return false;

		if (next_stack == null) {
			while (next_stack == null && index < container.getContainerSize()) {
				ItemStack get = container.getItem(index);

				if (!get.isEmpty()) {
					get.getCapability(cap).ifPresent(t -> next_stack = t);
				}

				index++;
			}
		}

		return next_stack != null;
	}

	@Override
	public T next() {
		T _next_stack = next_stack;
		next_stack = null;
		return _next_stack;
	}

	@Override
	public Iterator<T> iterator() {
		return this;
	}

	public void consume(Consumer<T> consumer) {
		for (T t : this) {
			consumer.accept(t);
		}
	}
}
